HDU 5323 Solve this interesting problem

搜索。。。

Solve this interesting problem

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 422    Accepted Submission(s): 98

Problem Description

Have you learned something about segment tree? If not, don’t worry, I will explain it for you.

Segment Tree is a kind of binary tree, it can be defined as this:

- For each node u in Segment Tree, u has two values: Lu and Ru.

- If Lu=Ru,
u is a leaf node.

- If Lu≠Ru,
u has two children x and y,with Lx=Lu,Rx=?Lu+Ru2?,Ly=?Lu+Ru2?+1,Ry=Ru.

Here is an example of segment tree to do range query of sum.

Given two integers L and R, Your task is to find the minimum non-negative n satisfy that: A Segment Tree with root node‘s value Lroot=0 and Rroot=n contains
a node u with Lu=L and Ru=R.

Input

The input consists of several test cases.

Each test case contains two integers L and R, as described above.

0≤L≤R≤109

LR?L+1≤2015

Output

For each test, output one line contains one integer. If there is no such n, just output -1.

Sample Input

6 7
10 13
10 11

Sample Output

7
-1
12

Source

2015 Multi-University Training Contest 3

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define prt(k) cout<<#k" = "<<k<<endl;
const ll inf = 1e18;
ll ans;
void dfs(ll L, ll R)
{
        if (R>=ans) return;
        if (L < 0) return;
        if(L==0) {
                ans = R;
                return;
        }
        if (R - L + 1 > L) return;
        dfs(2*L - R - 1,  R);
        dfs(2*L - R - 2, R);
        dfs(L, 2*R - L);
        dfs(L, 2*R - L + 1);
}
ll L, R;
int main()
{
        while (cin>>L>>R)
        {
                ans = inf;
                dfs(L, R);
                if (ans == inf) ans =  -1;
                cout<<ans<<endl;
        }
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-12-20 01:10:30

HDU 5323 Solve this interesting problem的相关文章

hdu 5323 Solve this interesting problem(dfs)

题目链接:hdu 5323 Solve this interesting problem 逆向思维,每次向左或向右翻倍,知道左端点为0时,即恰好满足的情况,处理处所有情况去取最小值. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; typedef long long ll; const ll inf = 0x3f3f3f3f; ll L, R, N; void

hdu 5323 Solve this interesting problem dfs 搜索

链接:http://acm.hdu.edu.cn/showproblem.php?pid=5323 Solve this interesting problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1470    Accepted Submission(s): 420 Problem Description Have you

HDU 5323 SOLVE THIS INTERESTING PROBLEM 爆搜

链接 Solve this interesting problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 511    Accepted Submission(s): 114 Problem Description Have you learned something about segment tree? If not, d

【搜索】 HDU 5323 Solve this interesting problem

点击打开链接 用线段树方式建树 [ 0, n] 已知[ l, r] 结点 求n 若 建一个[0, 2*r] 的线段树  这是的总点数的奇的,(左子树!=右子树 [0, r]  在左子树里 则n最大为2*r 若 建一个[0, 2*r+1] 的线段树 (左子树==右子树 [0, r]  在左子树里 这时则 [0, r] 就可以建树 所以搜的时候超出2*r 就直接return #include <cstdio> #include <cstring> #include <cstdli

DFS+剪枝 HDOJ 5323 Solve this interesting problem

题目传送门 1 /* 2 题意:告诉一个区间[L,R],问根节点的n是多少 3 DFS+剪枝:父亲节点有四种情况:[l, r + len],[l, r + len - 1],[l - len, r],[l - len -1,r]; 4 */ 5 #include <cstdio> 6 #include <algorithm> 7 #include <cstring> 8 #include <cmath> 9 #include <queue> 10

HDOJ 5323 Solve this interesting problem BFS搜索

BFS暴力搜索..... Solve this interesting problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 974    Accepted Submission(s): 263 Problem Description Have you learned something about segment tree?

多校3 1008 Solve this interesting problem

Solve this interesting problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1020    Accepted Submission(s): 279 Problem Description Have you learned something about segment tree? If not, don’

HDU 5323(2015多校3)-Solve this interesting problem(dfs+剪枝)

题目地址:HDU 5323 题意:给一个l,r,表示区间[l,r],问是否存在区间为[0,n]的线段树的节点区间为[l,r],如果有求最小的n,如果没有输出-1. 思路:因为L/(R-L+1)<=2015,按照线段树的性质每次分区间序号扩大两倍,所以可以得出差不多有22层,所以用爆搜就可以,由上把[l,r]区间不断扩张,直到满足l==0为止.顺便剪剪枝. #include <stdio.h> #include <math.h> #include <string.h>

hdu5323(2015多校3)--Solve this interesting problem(万万没想到,,,)

题目链接:点击打开链接 题目大意:给出一个区间[l,r],问这个区间能不能是一个线段树上的一段,线段树为0到n,求最小的n是多少. 按照题目给出的区间向根部搜,由子区间推到父区间,有四种可能(左右区间和(l+r)的奇偶性): [ l , 2*r-l ] [ l , 2*r+1-l ] [ (l-1)*2-r , r ] [ (l-1)*2+1-r , r ] 按照这四种方式向上搜,加上剪枝就可以AC 原因是l/(r-l+1) <= 2015,那么每向上搜一次,下面的区间和会增加两倍,l/区间和也